﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;

public partial class CS : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        if (!this.IsPostBack)
        {
            this.BindDataList();
        }
    }

    protected void SliderChanged(object sender, EventArgs e)
    {
        System.Threading.Thread.Sleep(2000); //Added for testing and hence remove.
        this.BindDataList();
    }

    private void BindDataList()
    {
        string constr = ConfigurationManager.ConnectionStrings["constr"].ConnectionString;
        int start = !string.IsNullOrEmpty(Request.Form[hfStart.UniqueID]) ? int.Parse(Request.Form[hfStart.UniqueID]) : 0;
        int end = !string.IsNullOrEmpty(Request.Form[hfEnd.UniqueID]) ? int.Parse(Request.Form[hfEnd.UniqueID]) : 0;
        lblSliderValue.Text = string.Format("Rs. {0} - Rs. {1}", start, end);
        using (SqlConnection con = new SqlConnection(constr))
        {
            string query = "SELECT * FROM Products WHERE (Price BETWEEN @Start AND @End) OR (@Start = 0 AND @End = 0);";
            query += "SELECT MIN(Price) [Min], MAX(Price) [Max] FROM Products";
            using (SqlCommand cmd = new SqlCommand(query))
            {
                cmd.Connection = con;
                cmd.Parameters.AddWithValue("@Start", start);
                cmd.Parameters.AddWithValue("@End", end);
                using (SqlDataAdapter sda = new SqlDataAdapter(cmd))
                {
                    DataSet ds = new DataSet();
                    sda.Fill(ds);
                    dlProducts.DataSource = ds.Tables[0];
                    dlProducts.DataBind();
                    if (!this.IsPostBack)
                    {
                        hfStart.Value = ds.Tables[1].Rows[0]["Min"].ToString();
                        hfEnd.Value = ds.Tables[1].Rows[0]["Max"].ToString();
                        lblSliderValue.Text = string.Format("Rs. {0} - Rs. {1}", hfStart.Value, hfEnd.Value);
                    }
                }
            }
        }
    }
}